stages:
  - build
  - release
  - deploy

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA
  RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest
  COMPOSE_FILE: docker-compose.prod.yml

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

Build:
  stage: build
  image: docker
  services:
    - docker:dind
  script:
    - docker build --pull -t $TEST_IMAGE .
    - docker push $TEST_IMAGE

Release:
  stage: release
  image: docker
  services:
    - docker:dind
  script:
    - docker pull $TEST_IMAGE
    - docker tag $TEST_IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE
  only:
    - master
    - prod

Deploy:
  stage: deploy
  tags:
    - deployment
  before_script:
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_KEY")
    - mkdir -p ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  script:
    - touch environment #create environment variables
    - echo "AWS_KEY=$AWS_KEY" >> environment
    - echo "AWS_SECRET=$AWS_SECRET" >> environment
    - echo "REGISTRY_IMAGE=$RELEASE_IMAGE" >> environment
    - scp ./environment $VM_IP:/etc/environment #copy to target machine
    - scp ./$COMPOSE_FILE $VM_IP:~/ # copy compose
    - ssh $VM_IP "docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY && docker-compose -f $COMPOSE_FILE pull && docker logout" #pull
    - ssh $VM_IP "docker-compose -f $COMPOSE_FILE down && docker-compose -f $COMPOSE_FILE up -d" #restart
  after_script:
    - shred  -vfu ./environment  # DESTROY
  only:
    - master
    - prod